using System.Text.Json;
using System.Text.Json.Serialization;

namespace View_by_Distance.Move.By.Id.Models;

public record AppSettings(string Company,
                          string MoveTo,
                          string ComparePathsFile,
                          int MaxDegreeOfParallelism,
                          int MaxMinutesDelta,
                          string WorkingDirectoryName)
{

    public override string ToString()
    {
        string result = JsonSerializer.Serialize(this, AppSettingsSourceGenerationContext.Default.AppSettings);
        return result;
    }

}

[JsonSourceGenerationOptions(WriteIndented = true)]
[JsonSerializable(typeof(AppSettings))]
internal partial class AppSettingsSourceGenerationContext : JsonSerializerContext
{
}