using System.Text.Json;
using System.Text.Json.Serialization;

namespace View_by_Distance.Shared.Models;

internal record FilePair(string Path,
                         bool IsUnique,
                         bool? IsNotUniqueAndNeedsReview,
                         List<string> Collection,
                         string? Match)
{

    public override string ToString()
    {
        string result = JsonSerializer.Serialize(this, FilePairSourceGenerationContext.Default.FilePair);
        return result;
    }

}

[JsonSourceGenerationOptions(WriteIndented = true)]
[JsonSerializable(typeof(FilePair))]
internal partial class FilePairSourceGenerationContext : JsonSerializerContext
{
}